/* 回避モード

	障害物を回避する。
	反転して、指定距離進む。

*/
    
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include "direction.h"
#include "io.h"
#include "position.h"
#include "request.h"
#include "routine.h"
#include "flag.h"
#include "speak.h"
#include "uss.h"

#define dist_avo 35

int speed, dist, dist_ref;

int threshold = 30;

double volt;

int routine_avoid(int avoid_flag){

	run_state_t run_state;
	//int angle_ref;

	const int speed_str = 30; // 直進速度 [cm/s]
	const int speed_return = 20;
	const double bat = 5.0;

	int us_f, us_b, us_l, us_r;
	int avo_st = 0;


	printf("\n 回避ルーチン開始\n");

	stop_flag = 0; // stop_flag をクリアする

	switch(avoid_flag){
		case 1:
			if( quit_flag == 1) return 0;

			//指定距離直進する
			dist_ref = -dist_avo;
			printf("回避モード : 後退\n");
			request_set_runmode(STR, speed_str, dist_ref);
			usleep(1000*1000);
			//後退
			while(1){

				if( quit_flag == 1 ) return 0;

				request_get_batt(&volt);
				if(volt <= 2.5){
					battery_flag = 1;
					return 0;
				}else if(volt <= bat){
					battery_flag = 2;
					return 0;
				}	

				if( uss_detection(&us_f, &us_b, &us_l, &us_r) > 0 ){
					request_get_runmode(&run_state, &speed, &dist_ref);
					printf("ぶつかりそうな為停止\n");
					avo_st = 1;
					usleep(1000);
					request_set_runmode(STP, 0, 0);
					clear_run_flag();
					break;
				}

				request_get_runmode(&run_state, &speed, &dist);
				if( run_state == STP ) {
					clear_run_flag();
					break;
				}
				//動作中に止まってしまった場合は停止して一旦回避モードを抜ける
				//if( stop_flag == 1){
				//	request_set_runmode(STP, 0 , 0);
				//	return 0; 
				//}	

				usleep(1000);
			}
			//待機
			speak(1);
			sleep(2);

			while(1){
				if( quit_flag == 1) return 0;

				request_get_batt(&volt);
				if(volt <= 0){
					battery_flag = 1;
					return 0;
				}else if(volt <= bat){
					battery_flag = 2;
					return 0;
				}	

				if( uss_detection(&us_f, &us_b, &us_l, &us_r) == 0 ) break;
	  			usleep(1000);

			}
			printf("障害物なしを確認\n");
			//指定距離直進する
			if(avo_st == 0){
				dist_ref = -dist_avo;
			}
			printf("復帰開始\n");
			request_set_runmode(STR, speed_return, -dist_ref);
			//復帰
			while(1){

				if( quit_flag == 1) return 0;

				request_get_batt(&volt);
				if(volt <= 2.5){
					battery_flag = 1;
					return 0;
				}else if(volt <= bat){
					battery_flag = 2;
					return 0;
				}	

				request_get_runmode(&run_state, &speed, &dist);
				if( run_state == STP ) {
					clear_run_flag();
					break;
				}
				//動作中に止まってしまった場合は停止して一旦回避モードを抜ける
				//if( stop_flag == 1){
				//	request_set_runmode(STP, 0 , 0);
				//	return 0; 
				//}	

				usleep(1000);
			}
			break;


		case 2:
			//指定距離直進する
			dist_ref = dist_avo;
			printf("回避モード : 直進\n");
			request_set_runmode(STR, speed_str, dist_ref);
			usleep(1000*1000);
			//前進
			while(1){

				if( quit_flag == 1) return 0;

				request_get_batt(&volt);
				if(volt <= 2.5){
					battery_flag = 1;
					return 0;
				}else if(volt <= bat){
					battery_flag = 2;
					return 0;
				}	

				if( uss_detection(&us_f, &us_b, &us_l, &us_r) > 0 ){
					request_get_runmode(&run_state, &speed, &dist_ref);
					printf("ぶつかりそうな為停止\n");
					avo_st = 1;
					usleep(1000);
					request_set_runmode(STP, 0, 0);
					clear_run_flag();
					break;
				}

              request_get_runmode(&run_state, &speed, &dist);
           	if( run_state == STP ) {
					clear_run_flag();
					break;
				}
				//動作中に止まってしまった場合は停止して一旦回避モードを抜ける
				//if( stop_flag == 1){
				//	request_set_runmode(STP, 0 , 0);
				//	return 0; 
				//}	

				usleep(1000);
			}
			speak(1);
			sleep(2);
			//待機
			while(1){

				if( quit_flag == 1) return 0;

				request_get_batt(&volt);
				if(volt <= 2.5){
					battery_flag = 1;
					return 0;
				}else if(volt <= bat){
					battery_flag = 2;
					return 0;
				}	

				if( uss_detection(&us_f, &us_b, &us_l, &us_r) == 0 ) break;
  				usleep(1000);

			}
			printf("障害物なしを確認\n");
			//指定距離直進する
			if(avo_st == 0){
				dist_ref = dist_avo;
			}
			printf("復帰開始\n");
			request_set_runmode(STR, speed_return, -dist_ref);
			//復帰
			while(1){

				if( quit_flag == 1) return 0;

				request_get_batt(&volt);
				if(volt <= 2.5){
					battery_flag = 1;
					return 0;
				}else if(volt <= bat){
					battery_flag = 2;
					return 0;
				}	

               	request_get_runmode(&run_state, &speed, &dist);
	         	if( run_state == STP ) {
					clear_run_flag();
					break;
				}
				//動作中に止まってしまった場合は停止して一旦回避モードを抜ける
				//if( stop_flag == 1){
				//	request_set_runmode(STP, 0 , 0);
				//	return 0; 
				//}	

				usleep(1000);
			}
			break;
		default:
			break;
	}
	avoid_flag = 0;
	printf("復帰終わり\n");
	request_set_runmode(STP, 0, 0);
	sleep(1);

	return 0;
}


