#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <wiringPi.h>
#include <wiringPiI2C.h>
#include "circle.h"
#include "io.h"
#include "request.h"
#include "routine.h"
#include "flag.h"
#include "uss.h"
#include "speak.h"
#include "light.h"
#include "timer2.h"

#define ACCESS_TOKEN "-----------------------"
#define MESSAGE_FULL "ゴミが一杯だよ"

typedef enum{FWD, BACK, ROT_C, END, DUMY} chase_state_t;

static int return_search();
static int io_sw_detection();
static run_state_t run_state;
int speed, dist, dist_tmp;
static int dist_move;
static int angle_ref;
static int infrared_io = 0;
int sw_det, uss_det;
int us_f, us_b, us_l, us_r;
int speed_str = 20;
int speed_rot = 30;
int rot_dist;
double bat = 5.0;

double volt;

int routine_trash_detection(){

	const int speed_str = 20;
	const int param     =  3;
	const int trash_y = 150;

	const int delay = 1000;
	
	int count = 0;

	int message_first = 1;

	int ratio, cir_x, cir_y;
	int trash_size, size_min;

	int speak_count = 0;

	int light_before = 0, light_open = 0, light_close = 0, light_close2 = 0;
	int fd = 0;
	fd = wiringPiI2CSetup(TSL2561_ADDR_FLOAT);
	
	chase_state_t state_curr = DUMY;

	char line_full[200];
	sprintf(line_full,"curl -X POST -H 'Authorization: Bearer %s ' -F 'message= %s ' https://notify-api.line.me/api/notify",ACCESS_TOKEN, MESSAGE_FULL);
	
	printf("\n追跡ルーチン開始\n");
	request_get_batt(&volt);
	usleep(500*1000);
	request_get_batt(&volt);
	usleep(500*1000);

	request_set_runmode(STR, speed_str, 500);
	usleep(1000);


	while(1){

		if( quit_flag == 1) return 0;
		request_get_batt(&volt);
		if(volt <= 2.5){
			battery_flag = 1;
			return 0;
		}else if(volt <= bat){
			battery_flag = 2;
			return 0;
		}
		
		count++;
		
		circle_get_cg(&cir_x, &cir_y, &ratio);
		
		if(ratio > param){
			printf("\r赤色を認識(y = %d)  ", cir_y);

			//赤丸を発見した
			circle_flag  = 1 ;

			state_curr = FWD;
			
		}else{
			printf("赤色を見失った\n");
			circle_flag  = 0 ;
			state_curr = END;
		}
		
		switch(state_curr){

		  case END:
			printf("追跡ルーチン終了\n");
			request_get_runmode(&run_state, &speed, &dist_move);
			request_set_runmode(STP, 0, 0);
			printf("cir_dir = %d\n",cir_dir);
			sleep(1);
			return_search();

			return 0; //風船を見失ったので追跡ルーチンを出る
			//break;

			//clear_run_flag();
			break;

		  case DUMY:
			break;

		  case FWD:

			speed = speed_str;

			if( quit_flag == 1) return 0;

			if (state == 0) {
				request_get_runmode(&run_state, &speed, &dist_move);
				request_set_runmode(STP, 0, 0);
				sleep(2);
				circle_flag = 0;
				escape_flag = 1;
				return_search();
				return 0;
			}

			request_get_batt(&volt);
			if(volt <= 2.5){
				battery_flag = 1;
				return 0;
			}else if(volt <= bat){
				battery_flag = 2;
				return 0;
			}

			sw_det = io_sw_detection();
			if(sw_det == 1){
				printf("前方スイッチ反応=1\n");
	  			avoid_flag = 1;
				request_set_runmode(STP, 0, 0);
				usleep(1000*1000);
				routine_avoid(avoid_flag);
				request_set_runmode(STR, speed_str, 500);
				usleep(1000*delay);
			}else if(sw_det == 2){
				printf("後方スイッチ反応\n");
		   		avoid_flag = 2;
				request_set_runmode(STP, 0, 0);
				usleep(1000*1000);
				routine_avoid(avoid_flag);
				request_set_runmode(STR, speed_str, 500);
				usleep(1000*delay);
			}else{
		    		avoid_flag = 0;
			}

	 		uss_det = uss_detection(&us_f, &us_b, &us_l ,&us_r);
	 		if(uss_det == 1){
				printf("前方超音波反応\n");
	   			avoid_flag = 1;
				request_set_runmode(STP, 0, 0);
				usleep(1000*1000);
				routine_avoid(avoid_flag);
				request_set_runmode(STR, speed_str, 500);
				usleep(1000*delay);
			}else if(uss_det == 2){
				printf("後方超音波反応\n");
	   			avoid_flag = 2;
				request_set_runmode(STP, 0, 0);
				usleep(1000*1000);
				routine_avoid(avoid_flag);
				request_set_runmode(STR, speed_str, 500);
				usleep(1000*delay);
			}else{
		  		avoid_flag = 0;
			}
			
			circle_get_cg(&cir_x, &cir_y, &ratio);

			///指定距離まで近づいたら止まる
			if( cir_y > trash_y ) {
				printf("ゴミの前まできた\n");
				request_get_runmode(&run_state, &speed, &dist_move);
				request_set_runmode(STP, 0, 0);
				set_stay(1);
				light_before = light_get(fd) + 2;
				trash_size = ratio;
				size_min = trash_size - 2;
				//size_max = trash_size + 2;
				timer2_srd_create();
				while(1){
					if(speak_count % 2 == 0){			
						speak(2);
					}
					speak_count++;

					if( quit_flag == 1) return 0;
					if( state == 0){
						circle_flag = 0;
						escape_flag = 1;
						timer2_cancel();
						clear_trash_timer();
						return_search();
						return 0;
					}

					request_get_batt(&volt);
					if(volt <= 2.5){
						battery_flag = 1;
						return 0;
					}else if(volt <= bat){
						battery_flag = 2;
						return 0;
					}

					if( trash_timer == 1){
						circle_flag = 0;
						//timer2_cancel();
						//clear_trash_timer();
						return_search();
						return 0;
					}

					circle_get_cg(&cir_x, &cir_y, &ratio);

					us_f = uss_get_f();
					if(us_f <= 40){
						sleep(2);
						us_f = uss_get_f();
						if(us_f <= 40){
							printf("足だった\n");
			 				circle_flag = 0;
							//timer2_cancel();
							//clear_trash_timer();
							return_search();
							return 0;
						}
					}
					
					if(ratio < size_min){
						printf("ゴミ消えた\n");
						printf("ふた開くの待ち\n");
						while(1){
							if( quit_flag == 1) return 0;
							if( state == 0){
								circle_flag = 0;
								escape_flag = 1;
								timer2_cancel();
								clear_trash_timer();
								return_search();
								return 0;
							}
							
							request_get_batt(&volt);
							if(volt <= 2.5){
								battery_flag = 1;
								return 0;
							}else if(volt <= bat){
								battery_flag = 2;
								return 0;
							}

							if( trash_timer == 1){
								circle_flag = 0;
								//timer2_cancel();
								//clear_trash_timer();
								return_search();
								return 0;
							}
							light_open = light_get(fd);
							//speak(6);//すてろと叫ぶ
							if(light_before < light_open){
								printf("ふた開いた\n");
								timer2_cancel();
								while(1){
									if( quit_flag == 1) return 0;
									if (state == 0) {
										circle_flag = 0;
										escape_flag = 1;
										return_search();
										return 0;
									}
									request_get_batt(&volt);
									if(volt <= 2.5){
										battery_flag = 1;
										return 0;
									}else if(volt <= bat){
										battery_flag = 2;
										return 0;
									}
									light_close = light_get(fd);
									if(light_close <= light_before){
										printf("ふた閉じた\n");
										speak(4);
										sleep(3);
										printf("満杯検知\n");
										get_infrared(&infrared_io);
										sleep(2);
										if( infrared_io == 1){
											printf("満杯だった\n");
											while( infrared_io == 1 || light_close2 > light_before ){
												if( quit_flag == 1) return 0;
												if (state == 0) {
													circle_flag = 0;
													escape_flag = 1;
													return_search();
													return 0;
												}
												request_get_batt(&volt);
												if(volt <= 2.5){
													battery_flag = 1;
													return 0;
												}else if(volt <= bat){
													battery_flag = 2;
													return 0;
												}
												get_infrared(&infrared_io);
												if(infrared_io == 1){
													printf("満杯中\n");
													speak(5);
													//sleep(2);
												}
												light_close2 = light_get(fd);
												if( light_close2 > light_before ){
													printf("ふた開いてる\n");
													speak(3);
													//sleep(2);
												}
												if(message_first == 1){
													system(line_full);
													//printf("LINEに送った\n");
													message_first = 0;
												}
												sleep(3);
											}
											printf("満杯じゃない\n");
											goto search;
										}
										goto search;
									}
								usleep(1000);
								}
						
							usleep(200);
							}
						usleep(100);
						}
					}
				usleep(100);
				}
search:		
				return_search();
				return 0;					
			}

			printf("直進中\n");
			usleep(1000);

			break;
		default:
			break;
		}
		usleep(20 * 1000);
	}
	
	return 0;
}


int return_search(){
	const int delay = 1000;
	int dist_tmp_total = 0;
	
	//request_set_runmode(ROT, speed_rot, 180);
	//sleep(10);
	printf("巡回ルートへ戻る\n");

	request_set_runmode(STR, speed_str, -dist_move );
	sleep(1);
	while(1){
		if( quit_flag == 1) return 0;
		request_get_batt(&volt);
		if(volt <= 2.5){
			battery_flag = 1;
			return 0;
		}else if(volt <= bat){
			battery_flag = 2;
			return 0;
		}		

		sw_det = io_sw_detection();
		if(sw_det == 1){
			printf("前方スイッチ反応=1\n");
			avoid_flag = 1;
			request_get_runmode(&run_state, &speed, &dist_tmp);
			request_set_runmode(STP, 0, 0);
			usleep(1000);
			routine_avoid(avoid_flag);
			dist_tmp_total += dist_tmp;
			if(-dist_move + dist_tmp_total < 0){
				request_set_runmode(STR, speed_str, -dist_move + dist_tmp_total);
			}else{
				request_set_runmode(STP, 0, 0);
			}
			usleep(1000*delay);
		}else if(sw_det == 2){
			printf("後方スイッチ反応\n");
		   	avoid_flag = 2;
			request_get_runmode(&run_state, &speed, &dist_tmp);
			request_set_runmode(STP, 0, 0);
			usleep(1000);
			routine_avoid(avoid_flag);
			dist_tmp_total += dist_tmp;
			if(-dist_move + dist_tmp_total < 0){
				request_set_runmode(STR, speed_str, -dist_move + dist_tmp_total);
			}else{
				request_set_runmode(STP, 0, 0);
			}
			usleep(1000*delay);
		}else{
		    avoid_flag = 0;
		}

		uss_det = uss_detection(&us_f, &us_b, &us_l ,&us_r);
		if(uss_det == 1){
			printf("前方超音波反応\n");
		   	avoid_flag = 1;
			request_get_runmode(&run_state, &speed, &dist_tmp);
			request_set_runmode(STP, 0, 0);
			usleep(1000);
			routine_avoid(avoid_flag);
			dist_tmp_total += dist_tmp;
			if(-dist_move + dist_tmp_total < 0){
				request_set_runmode(STR, speed_str, -dist_move + dist_tmp_total);
			}else{
				request_set_runmode(STP, 0, 0);
			}
			usleep(1000*delay);
		}else if(uss_det == 2){
			printf("後方超音波反応\n");
		   	avoid_flag = 2;
			request_get_runmode(&run_state, &speed, &dist_tmp);
			request_set_runmode(STP, 0, 0);
			usleep(1000);
			routine_avoid(avoid_flag);
			dist_tmp_total += dist_tmp;
			if(-dist_move + dist_tmp_total < 0){
				request_set_runmode(STR, speed_str, -dist_move + dist_tmp_total);
			}else{
				request_set_runmode(STP, 0, 0);
			}
			usleep(1000*delay);
		}else{
		   	avoid_flag = 0;
		}
		usleep(1000*1000);
		request_get_runmode(&run_state, &speed, &dist);
		if( run_state == STP ){
			request_set_runmode(STP, 0, 0);
					
			sleep(1);
			printf("cir_dir = %d\n",cir_dir);
			angle_ref = cir_dir;
			request_set_runmode(ROT, speed_rot, angle_ref);
			sleep(5);
			circle_flag = 0;
			return 0;
		}
		usleep(1000);
	}
}

int io_sw_detection(){
	int sw_1, sw_2, sw_3, sw_4, sw_5, sw_6, sw_7, sw_8;
	io_get_sw(&sw_1, &sw_2, &sw_3, &sw_4, &sw_5, &sw_6, &sw_7, &sw_8);
	if(sw_1 == 0 || sw_2 == 0 || sw_3 == 0 || sw_4 == 0 ){
		return 1;
	}

	if(sw_5 == 0 || sw_6 == 0 || sw_7 == 0 || sw_8 == 0 ){
		return 2;
	}

	return 0;
}

